/*
 * @(#)IDD.java - Mpeg2Schnitt export
 *
 * Copyright (c) 2003 by JLA.
 *
 * This file is an extension of X, a free Java based demux utility.
 * X is intended for educational purposes only, as a non-commercial test project.
 * It may not be used otherwise. Most parts are only experimental.
 * 
 *
 * This program is free software; you can redistribute it free of charge
 * and/or modify it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
import java.io.*;

/**
 *
 * <p>Title: IDD export</p>
 * <p>Description: module to export a file readable by the program Mpeg2Schnitt@Martin Dienert</p>
 * <p>Copyright: Copyright (c) 2003 JLA</p>
 * <p>Company: </p>
 * @author johann.langhofer@nextra.at(JLA)
 * @version 1.0 06082003
 */
public class IDD {

class TSpecialOutputStream extends DataOutputStream{
    public TSpecialOutputStream(OutputStream out) {
	super(out);
    }
    public final void writeShortS(int v) throws IOException {
	OutputStream out = this.out;
	out.write((v >>> 0) & 0xFF);
	out.write((v >>> 8) & 0xFF);
	incCount(2);
    }
    public final void writeIntS(int v) throws IOException {
	OutputStream out = this.out;
	out.write((v >>>  0) & 0xFF);
	out.write((v >>>  8) & 0xFF);
	out.write((v >>> 16) & 0xFF);
	out.write((v >>> 24) & 0xFF);
	incCount(4);
    }
    public final void writeLongS(long v) throws IOException {
	OutputStream out = this.out;
	out.write((int)(v >>>  0) & 0xFF);
	out.write((int)(v >>>  8) & 0xFF);
	out.write((int)(v >>> 16) & 0xFF);
	out.write((int)(v >>> 24) & 0xFF);
	out.write((int)(v >>> 32) & 0xFF);
	out.write((int)(v >>> 40) & 0xFF);
	out.write((int)(v >>> 48) & 0xFF);
	out.write((int)(v >>> 56) & 0xFF);
	incCount(8);
    }
    private void incCount(int value) {
        int temp = written + value;
        if (temp < 0) {
            temp = Integer.MAX_VALUE;
        }
        written = temp;
    }


}
String iddfile = "";
TSpecialOutputStream dos=null;
  /**
   * writing IDD-Version 02 header
   * @param fparent
   */
  public void Init(String fparent) {
    iddfile = fparent+".idd";
    try {
      dos= new TSpecialOutputStream(new FileOutputStream(iddfile));
      dos.write('i');
      dos.write('d');
      dos.write('d');
      dos.write(02);

    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
  public TSpecialOutputStream getStream() {
    return dos;
  }

  public void close(long adr) {
    try {
      dos.write(0xb7);
      dos.writeLongS(adr);
      dos.close();
    }
    catch (Exception ex) {
    }
  }

  public static class TGOPHeader {
    byte code=(byte)0xb8;
    long Adresse;
    boolean drop;
    byte hours;
    byte minutes;
    boolean marker;
    byte seconds;
    byte picture;
    boolean closed;
    boolean broken;
    public TGOPHeader() {
    }

    public TGOPHeader(long adr,byte[] gop, int off) {
      int s=off-4;
      Adresse=adr;
    }
    public void write(TSpecialOutputStream dos) {
      try {
        dos.writeByte(code);
        dos.writeLongS(Adresse);
      }
      catch (Exception ex) {
        ex.printStackTrace();
      }
    }
    public String toString() {
      String ret="@"+Long.toHexString(Adresse)+"/d:"+drop+"/"+hours+":"+minutes+":"+seconds+"/p:"+picture+"/c:"+closed+"/b:"+broken;
      return ret;
    }
    public static String  dump(long adr,byte[] gop,int off) {
      TGOPHeader ts=new TGOPHeader(adr,gop,off);
      return ts.toString();
   }
  }

  public static class TPictureHeader {
    byte code=(byte)0x00;
    long Adresse;
    short TempRefer;
    byte BildTyp;
    short VBVDelay;
    byte FCode0;
    byte FCode1;
    byte FCode2;
    byte FCode3;
    byte IntraDCPre;
    byte BildStruktur;
    boolean OberstesFeldzuerst;
    boolean frame_pred_frame_dct;
    boolean concealment_motion_vectors;
    boolean q_scale_type;
    boolean intra_vlc_format;
    boolean alternate_scan;
    boolean repeat_first_field;
    boolean chroma_420_type;
    boolean progressive_frame;
    boolean composite_display_flag;
    boolean v_axis;
    byte field_sequence;
    boolean sub_carrier;
    byte burst_amplitude;
    byte sub_carrier_phase;

    public TPictureHeader() {
    }
    public TPictureHeader(long adr,byte[] gop, int off) {
      int s=off-4;
      Adresse=adr;
      TempRefer=(short)((255&gop[s+4]<<2)|(0xc0&gop[s+5])>>>6);
      BildTyp=(byte)((0x38&gop[s+5])>>>3);
    }
    public void write(TSpecialOutputStream dos) {
      try {
        dos.writeByte(code);
        dos.writeLongS(Adresse);
        dos.writeShortS(TempRefer);
        dos.writeByte(BildTyp);
      }
      catch (Exception ex) {
        ex.printStackTrace();
      }
    }
    public String toString() {
      String ret="@"+Long.toHexString(Adresse)+"/"+TempRefer+"/"+BildTyp+"/"+VBVDelay;
      return ret;
    }
    public static String dump(long adr,byte[] gop,int off) {
      TPictureHeader ts= new TPictureHeader(adr,gop,off);
      return ts.toString();
    }
  }

  public static class TSequenceHeader {
    byte code=(byte)0xb3;
    long Adresse;
    short BildBreite;
    short BildHoehe;
    byte Seitenverhaeltnis;
    byte Framerate;
    int Bitrate;
    short VBVPuffer;
    byte  ProfilLevel;
    boolean Progressive;
    byte ChromaFormat;
    boolean LowDelay;
    public TSequenceHeader() {
    }
    public TSequenceHeader(long adr,byte[] gop, int off) {
      int s=off-4;
      Adresse=adr;
    }
    public void write(TSpecialOutputStream dos) {
      try {
        dos.writeByte(code);
        dos.writeLongS(Adresse);
      }
      catch (Exception ex) {
        ex.printStackTrace();
      }
    }
    public String toString() {
      String ret="@"+Long.toHexString(Adresse)+"/w:"+BildBreite+"/h:"+BildHoehe+"/a:"+Seitenverhaeltnis+"/f:"+Framerate+"/b:"+Bitrate+"/v:"+VBVPuffer;
      return ret;
    }
    public static String dump(long adr,byte[] gop,int off) {
      TSequenceHeader ts= new TSequenceHeader(adr,gop,off);
      return ts.toString();
    }
  }
}

