/*
 * @(#)SCAN.java - pre-scanning to check supported files
 *
 * Copyright (c) 2002/2003 by dvb.matt. 
 * 
 * This file is part of X, a free Java based demux utility.
 * X is intended for educational purposes only, as a non-commercial test project.
 * It may not be used otherwise. Most parts are only experimental.
 * 
 *
 * This program is free software; you can redistribute it free of charge
 * and/or modify it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


import java.io.*;
import java.util.*;

public class SCAN {

String[] type = { 
	"Filetype not supported",
	"PVA (Video/Audio PES)",
	"MPEG-1 PS/SS (Video/Audio PES)",
	"MPEG-2 PS/SS (Video/Audio PES)",
	"PES (Video/Audio/TTX)",
	"PES (MPEG Audio)",
	"PES (private stream 1)",
	"ES (AC-3 Audio)",
	"ES (MPEG Audio)",
	"ES (MPEG Video)",
	"ES (AC-3 Audio) (psb. SMPTE)",
	"DVB/MPEG2 TS" 
};

String video =" ", audio=" ", addInfo="", origFile="", playtime="";
ArrayList pidlist = new ArrayList();
boolean hasVideo=false, nullpacket=false;
byte[] vbasic = new byte[12];
AUDIO Audio = new AUDIO();
VIDEO vfc = new VIDEO();

java.text.DateFormat timeformat = new java.text.SimpleDateFormat("HH:mm:ss.SSS");

public int inputInt(String file) { 
	return testFile(file,false); 
}

public String Type(String file) { 
	origFile=file; 
	return type[testFile(file,true)]+addInfo; 
}

public String Date(String file) {
	return java.text.DateFormat.getDateInstance(java.text.DateFormat.LONG).format(new java.util.Date(new File(file).lastModified()))+"  "+java.text.DateFormat.getTimeInstance(java.text.DateFormat.LONG).format(new java.util.Date(new File(file).lastModified()));
}
 
public String Video() { 
	return video; 
}

public String Audio() { 
	return audio; 
}

public String Playtime() { 
	return playtime; 
}

public boolean isEditable() { 
	return (new File(origFile).exists() && hasVideo); 
}

public String getFile() { 
	return origFile; 
}

public byte[] getVBasic() { 
	return vbasic; 
}

public void AC3Audio(byte[] check) { 
	audiocheck:
	for (int a=0; a<10000; a++) {
		if (Audio.AC3_parseHeader(check,a) < 0)
			continue audiocheck;
		for (int b=0;b<17;b++) {
			if (Audio.AC3_parseNextHeader(check,a+Audio.Size+b) == 1){
				if ( (0xFF&check[a+Audio.Size]) > 0x3f || (0xFF&check[a+Audio.Size])==0 ) //smpte
					continue audiocheck;
				audio = Audio.AC3_saveAnddisplayHeader();
				return;
			}
		}
	} 
}

public void MPEGAudio(byte[] check) { 
	audiocheck:
	for (int a=0; a<10000; a++) {
		if (Audio.MPA_parseHeader(check,a) < 0)
			continue audiocheck;
		if (Audio.MPA_parseNextHeader(check,a+Audio.Size) < 0)
			continue audiocheck;
		audio = Audio.MPA_saveAnddisplayHeader();
		return;
	}
}

public byte[] loadPES(byte[] check, int a) { 
	ByteArrayOutputStream bytecheck = new ByteArrayOutputStream();
	while (bytecheck.size() < 11000) {
		int jump = (255&check[a+4])<<8 | (255&check[a+5]);
		bytecheck.write(check,a+6+3+(255&check[a+8]),jump-3-(255&check[a+8]) );
		a += 6+jump;
	}
	return bytecheck.toByteArray();
}

public void loadMPG2(byte[] check, int b, boolean vdr, boolean mpg1) { 
	ByteArrayOutputStream vid = new ByteArrayOutputStream();
	ByteArrayOutputStream aud = new ByteArrayOutputStream();
	ByteArrayOutputStream ac3 = new ByteArrayOutputStream();
	int jump = 1;

	mpg2check:
	for (int a=b; a<500000; a+=jump) {
		if ( check[a]!=0 || check[a+1]!=0 || check[a+2]!=1 ) { 
			jump=1; 
			continue mpg2check; 
		}
		if ( (0xf0 & check[a+3]) == 0xe0) {
			jump = 6+((255&check[a+4])<<8 | (255&check[a+5]));
			if (nullpacket) 
				jump = 2048;
			vid.write(check,a+6+((!mpg1) ? 3+(255&check[a+8]) : 0),jump-((!mpg1) ? 6-3-(255&check[a+8]) : 0) );
		} else if ( (0xf0 & check[a+3]) == 0xc0) {
			jump = 6+((255&check[a+4])<<8 | (255&check[a+5]));
			aud.write(check,a+6+3+(255&check[a+8]),jump-6-3-(255&check[a+8]) );
		} else if ( (0xff & check[a+3]) == 0xbd) {
			jump = 6+((255&check[a+4])<<8 | (255&check[a+5]));
			if (!vdr) 
				ac3.write(check,a+6+7+(255&check[a+8]),jump-6-7-(255&check[a+8]) );
			else 
				ac3.write(check,a+6+3+(255&check[a+8]),jump-6-3-(255&check[a+8]) );
		} else {
			switch (0xFF & check[a+3]) {
			case 0xBB:
			case 0xBE:
			case 0xBF:
			case 0xF0:
			case 0xF1:
			case 0xF2:
			case 0xF3:
			case 0xFF: { 
				jump = 6+((255&check[a+4])<<8 | (255&check[a+5])); 
				break; 
			}
			default: 
				jump=1;
			}
		}
	}

	try 
	{
	if ( vid.size()>0 ) 
		checkVid(vid.toByteArray());
	else 
		video="no video found";
	} 
	catch  ( Exception e) { 
		video = "error while checking"; 
	}

	try 
	{
	if ( ac3.size()>0 ) 
		AC3Audio(ac3.toByteArray());
	else if ( aud.size()>0 ) 
		MPEGAudio(aud.toByteArray());
	else 
		audio="no main audio";
	} 
	catch  ( Exception e) { 
		audio = "error while checking"; 
	}

	return;
}

public void loadPVA(byte[] check, int a) { 
	ByteArrayOutputStream vid = new ByteArrayOutputStream();
	ByteArrayOutputStream aud = new ByteArrayOutputStream();
	int number = 0x10000;

	while ( a < 550000) {
		int jump = (255&check[a+6])<<8 | (255&check[a+7]);
		if (a+8+((1 & check[a+5]>>>4)*4)+jump > 700000) 
			break;
		switch (255 & check[a+2]) {
		case 1: { 
			vid.write(check,a+8+((1 & check[a+5]>>>4)*4),jump ); 
			break; 
		}
		case 0x80: 
		case 2: { 
			aud.write(check,a+8,jump ); 
			break; 
		}
		}
		a += 8+jump;
	}

	//addInfo = " ( "+Integer.toBinaryString(number).substring(4,17)+" )";

	try 
	{
	if (vid.size()>0) 
		checkVid(vid.toByteArray());
	else 
		video="no video found";
	}
	catch  ( Exception e) { 
		video = "error while checking"; 
	}

	try 
	{
	if (aud.size()>0) 
		checkPES(aud.toByteArray());
	else 
		audio="no audio found";
	} catch  ( Exception e) { 
		audio = "error while checking"; 
	}

	return;
}

public void checkPES(byte[] check) { 
	rawcheck:
	for (int a=0; a<8000; a++) {
		if ( check[a]!=0 || check[a+1]!=0 || check[a+2]!=1 ) 
			continue rawcheck;
		if ( (0xf0 & check[a+3])==0xc0 || check[a+3]==(byte)0xbd ) {
			int next = a+6+( (255&check[a+4])<<8 | (255&check[a+5]) );
			if ( check[next]!=0 || check[next+1]!=0 || check[next+2]!=1 ) 
				continue rawcheck;
			if ( (0xf0 & check[a+3])==0xc0 && (0xf0 & check[a+3])==(0xf0 & check[next+3]) ) {
				MPEGAudio(loadPES(check,a));
				return;
			} else if ( check[a+3]==(byte)0xbd && check[a+3]==check[next+3] ) {
				AC3Audio(loadPES(check,a));
				return;
			}
		}
	}
}

public void checkVid(byte[] check) { 
	ByteArrayOutputStream bytecheck = new ByteArrayOutputStream();
	video = "no sequence header in first 600kB";

	mpvcheck:
	for (int a=0; a<check.length-630; a++) {
		if ( check[a]!=0 || check[a+1]!=0 || check[a+2]!=1 || check[a+3]!=(byte)0xb3 ) 
			continue mpvcheck;
		for (int b=7;b<600;b++) {
			if ( check[a+b]==0 && check[a+b+1]==0 && check[a+b+2]==1 && check[a+b+3]==(byte)0xb8 ) {
				hasVideo=true;
				System.arraycopy(check,a,vbasic,0,12);
				bytecheck.write(check,a,20);
				video = vfc.videoformatByte(bytecheck.toByteArray());
				return;
			}
		} 
	} 
	return;
}

public void PMTcheck(byte[] check, int a) { 
	ByteArrayOutputStream bytecheck = new ByteArrayOutputStream();
	video = "no PMT found";
	audio = "no PMT found";
	pidlist.clear();

	tscheck:
	for ( ; a<check.length-1000; a++) {
		if ( check[a]!=0x47 || check[a+188]!=0x47 || check[a+376]!=0x47 ) 
			continue tscheck;
		if ( (0x30&check[a+3])!=0x10 || check[a+4]!=0 || check[a+5]!=2 || (0xf0&check[a+6])!=0xb0 ) { 
			a+=187; 
			continue tscheck; 
		}
		bytecheck.write(check,a+4,184);
		int pmtpid = (0x1F & check[a+1])<<8 | (0xFF & check[a+2]);
		if ( bytecheck.size()<188 ) { 
			a+=188;
			addpack:
			for ( ; a<check.length-500; a++) {
				if ( check[a]!=0x47 || check[a+188]!=0x47 || check[a+376]!=0x47 ) 
					continue addpack;
				if ( ((0x1F & check[a+1])<<8 | (0xFF & check[a+2]))!=pmtpid || (0x40&check[a+1])!=0 || (0x30&check[a+3])!=0x10 ) { 
					a+=187; 
					continue addpack; 
				}
				bytecheck.write(check,a+4,184);
				if ( bytecheck.size()>188 ) 
					break addpack;
			}
		}
		byte[] pmt = bytecheck.toByteArray();
		if (pmt.length>5) {
			int sid = (0xFF & pmt[4])<<8 | (0xFF & pmt[5]);
			pidlist.add(""+sid);
			pidlist.add(""+pmtpid);
			addInfo+=" (SID 0x"+Integer.toHexString(sid).toUpperCase()+" ,PMT 0x"+Integer.toHexString(pmtpid).toUpperCase()+")";
		}
		video="PIDs: ";
		audio="PIDs: ";

		pidsearch:
		for (int b=8, r=8; b<pmt.length-6; b++) { //DM18092003 fix
			r=b;
			if ( (0xe0&pmt[b+1])!=0xe0 ) 
				continue pidsearch;
			int pid = (0x1F & pmt[b+1])<<8 | (0xFF & pmt[b+2]);

			switch ( 0xFF&pmt[b] ) {
			case 2 : { 
				video+="0x"+Integer.toHexString(pid).toUpperCase()+" "; 
				b+=4+(0xFF&pmt[b+4]);
				pidlist.add(""+pid); 
				break; 
			} 
			case 3 :
			case 4 : { 
				audio+="0x"+Integer.toHexString(pid).toUpperCase()+" "; 
				b+=4+(0xFF&pmt[b+4]);
				pidlist.add(""+pid); 
				break; 
			} 
			case 0x80: 
			case 0x81: 
			case 0x82: 
			case 0x83: 
			case 6 : { 
				video+="(PD 0x"+Integer.toHexString(pid).toUpperCase()+") "; 
				b+=4+(0xFF&pmt[b+4]);
				pidlist.add(""+pid); 
				break; 
			} 
			default: 
				b+=4+(0xFF&pmt[b+4]);
			}
			if (b<0) 
				b=r;
		}
		return;
	} 
	return;
}

public int[] getPIDs() {
	int[] b = new int[pidlist.size()];
	for (int a=0; a<pidlist.size();a++) 
		b[a] = Integer.parseInt(pidlist.get(a).toString());
	return b;
}

public String getAudioTime(long len) {
	return timeformat.format(new java.util.Date((len*8000)/Audio.Bitrate));
}

public int testFile(String infile, boolean more) {
	video = "no video found";
	audio = "no audio found"; 
	addInfo="";
	playtime="";
	hasVideo=false; 
	nullpacket=false;
	long size = 0;
	timeformat.setTimeZone(java.util.TimeZone.getTimeZone("GMT+0:00"));

	byte[] check= new byte[630000];
	ByteArrayOutputStream bytecheck = new ByteArrayOutputStream();
   
	try 
	{
	RandomAccessFile incheck = new RandomAccessFile( infile,"r" );
	size = incheck.length();
	incheck.seek(0);
	incheck.read(check);
	incheck.close();

	mpegtscheck:
	for (int a=0; a<20000; a++) {
		if ( check[a]!=(byte)0x47 || check[a+188]!=(byte)0x47 || check[a+376]!=(byte)0x47 || check[a+564]!=(byte)0x47 || check[a+752]!=(byte)0x47) 
			continue mpegtscheck;
		PMTcheck(check,a);
		return 11;
	}

	pvacheck:
	for (int a=0; a<20000; a++) {
		if ( check[a]!=(byte)0x41 || check[a+1]!=(byte)0x56 || check[a+4]!=(byte)0x55 ) 
			continue pvacheck;
		int next = a+8+( (255&check[a+6])<<8 | (255&check[a+7]) );
		if ( check[next]!=(byte)0x41 || check[next+1]!=(byte)0x56 || check[next+4]!=(byte)0x55 ) 
			continue pvacheck;
		else {
			if (more) 
				loadPVA(check,a);
			return 1;
		}
	}

	mpgcheck:
	for (int a=0; a<100000; a++) {
		if ( check[a]!=0 || check[a+1]!=0 || check[a+2]!=1 || check[a+3]!=(byte)0xba ) 
			continue mpgcheck;
		if ( (0xC0 & check[a+4])==0 ) { 
			if (more) 
				loadMPG2(check,a,false,true); 
			return 2;
		} else if ( (0xC0 & check[a+4])==0x40 ) {
			if (more) 
				loadMPG2(check,a,false,false); 
			return 3;
		}
	}

	vdrcheck:
	for (int a=0; a<140000; a++) {
		if ( check[a]!=0 || check[a+1]!=0 || check[a+2]!=1 || (0xF0&check[a+3])!=0xe0 ) 
			continue vdrcheck;
		int next = a+6+( (255&check[a+4])<<8 | (255&check[a+5]) );
		if (next==a+6 && (0xC0&check[a+6])==0x80 && (0xC0&check[a+8])==0) { 
			addInfo += " !!(Vpacketsize=0)"; 
			next=a; 
			nullpacket=true; 
		}
		if ( check[next]!=0 || check[next+1]!=0 || check[next+2]!=1 ) 
			continue vdrcheck;
		else {
			if (more) 
				loadMPG2(check,a,true,false); 
			return 4;
		}
	}

	rawcheck:
	for (int a=0; a<100000; a++) {
		if ( check[a]!=0 || check[a+1]!=0 || check[a+2]!=1 ) 
			continue rawcheck;
		if ( (0xf0 & check[a+3])==0xc0 || (255 & check[a+3])==0xbd ) {
			int next = a+6+( (255&check[a+4])<<8 | (255&check[a+5]) );
			if ( check[next]!=0 || check[next+1]!=0 || check[next+2]!=1 ) 
				continue rawcheck;
			if ( (0xE0 & check[a+3])==0xC0 && (0xE0 & check[a+3])==(0xE0 & check[next+3]) ) {
				if (more) 
					MPEGAudio(loadPES(check,a));
				return 5;
			} else if ( (255&check[a+3])==0xbd && check[a+3]==check[next+3] ) {
				if (more) {
					if (check[a+8]==0x24 && check[a+9+0x24]==0x10) 
						addInfo=" (TTX)";
					else 
						AC3Audio(loadPES(check,a));
				}
				return 6;
			}
		}
	}

	audiocheck:
	for (int a=0; a<10000; a++) {
		if (Audio.AC3_parseHeader(check,a) > 0) {
			for (int b=0;b<17;b++) {
				if (Audio.AC3_parseNextHeader(check,a+Audio.Size+b) == 1){
					if ( (0xFF&check[a+Audio.Size]) > 0x3f || (0xFF&check[a+Audio.Size])==0 ) //smpte
						continue audiocheck;
					if (more){
						audio = Audio.AC3_saveAnddisplayHeader();
						playtime = getAudioTime(size);
					}
					if (b==0)
						return 7;
					else 
						return 10;
				}
			}
		} else if (Audio.MPA_parseHeader(check,a) > 0) {
			if (Audio.MPA_parseNextHeader(check,a+Audio.Size) < 0)
				continue audiocheck;
			if (more){
				audio = Audio.MPA_saveAnddisplayHeader();
				playtime = getAudioTime(size);
			}
			return 8;
		}
	} 

	mpvcheck:
	for (int a=0; a<250000; a++) {
		if ( check[a]!=0 || check[a+1]!=0 || check[a+2]!=1 ) 
			continue mpvcheck;
		if ( check[a+3]==(byte)0xb3 ) {
			for (int b=7;b<600;b++)
				if ( check[a+b]==0 && check[a+b+1]==0 && check[a+b+2]==1 && check[a+b+3]==(byte)0xb8 ) {
					if (more) { 
						hasVideo=true;
						System.arraycopy(check,a,vbasic,0,12);
						bytecheck.write(check,a,20);
						video = vfc.videoformatByte(bytecheck.toByteArray());
					}
					return 9;
				}
		} else if ( check[a+3]==(byte)0xb8 ) {
			for (int b=6;b<20;b++) 
				if ( check[a+b]==0 && check[a+b+1]==0 && check[a+b+2]==1 && check[a+b+3]==0 ) { 
					if (more) 
						video = "file doesn't start with a sequence header!";
					return 9;
				}
		} 
	} 

	} 
	catch ( IOException e ) { }

	return 0;
}


} /** end class **/
